/*				TRABALHO ESTRUTURA DE DADOS I
				Agenda com Aplicao de Lista Linear com Arquivo

		Pontifcia Universidade Catlica	- Campinas
		Engenharia de Computao			- 2 Semestre

	Alunos:
		Cesar Henrique Kallas				- RA: 02099224
			opensrc@gmx.net

		Daniel Figueiredo Machado			- RA: 02508224
			daniel.fm@uol.com.br

	Entrega:
		12/11/2002	Tera Feira
		Sala	16
	
	Escopo: Agenda de contatos com lista linear, essa versao usa arquivos
para gravar os contatos no disco, a biblioteca Listaarq.h deve estar no mesmo
diretorio para compilacao.

    g++ agenda_arquivo_ed1.cpp -o agenda
*/

#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#define pause system("sleep 5");	//para windows use system("PAUSE")
#define limpa system("clear");		//para windows use system("cls")
#define sub_titulo "\n\xDB\n\xDB\xDB\xDB\xDB\t"
#define nome_arquivo	"agenda.dat"

struct pessoa {
    char  nome[50];
    char  ende[50];
    char   tel[12];
	char email[20];
};

typedef pessoa tipo_do_elemento;
#include "listaarq.h"

void nome()
{
	limpa;
	cout << "\n";
	for(int i=0;i<=40;i++)
	cout << "\xDC";
	cout << "\n\xDB" ;
	cout << "\n\xDB\t\tSISTEMA AGENDA\n\xDB";
}

void inserir_cadastro(int i,Lista &A)
{
	tipo_do_elemento v;
	cout << "\xDB\n\xDB  NUMERO(" << i << ")";
	cout << "\n\xDB Nome......: ";cin.getline(v.nome,50);
	cout << "\xDB Endereco..: "; cin.getline(v.ende,50);
	cout << "\xDB Email.....: "; cin.getline(v.email,12);
	cout << "\xDB Telefone..: "; cin.getline(v.tel,12);
	inserir(A,v,i);
}

void leitura(Lista &A)
{
	nome();
	int n,i=0;
	if(compr(A)==0)
		cout << sub_titulo << "NOVA AGENDA\n";
			else
		{
			cout << sub_titulo << "CRIANDO NOVA AGENDA\n";
			cout << "\xDB\n\xDB Para criar NOVA agenda e excluir a anterior, digite [0] : " << flush;
		cin >> i;
		}
	if(i==0)
	{
	cout << "\xDB\n\xDB  Numero de cadastro(s) : ";
	cin.get();
	cin >> n;
	cin.get();
	if(n!=0)
	{
	init(A);
	for(i=1;i<=n;i++)
    {
		inserir_cadastro(i,A);
		limpa;
		nome();
		cout << sub_titulo << "NOVA AGENDA\n";
	}
	cout << "\xDB\n\xDB\xDB Dados inseridos com sucesso!\n" << flush;
	}
		else
	cout << "\xDB\n\xDB\xDB Numero invalido!\n" << flush;
	}
		else
	cout << "\xDB\n\xDB\xDB Agenda NAO modificada!\n" << flush;
	
	cout << "\xDB\n\xDB  " << flush;
	pause;
	
}

void incluir(Lista &A)
{
	int i;
	i=compr(A);
	nome();
	cout << sub_titulo << "INCLUIR CADASTRO\n" << flush;
	if(i!=0)
	{
		i=i+1;	// 'i'  o tamanho total da lista, se refere ao ultimo cadastro, intao o proximo eh o ultimo mais 1 >> (i=i+1)
		cin.get();
		inserir_cadastro(i,A);
	}
		else
	cout << "\xDB\n\xDB\xDB  Agenda vazia !\n" << flush;
	cout << "\xDB\n\xDB  " << flush;
	pause;
}

void imprime_pessoa(tipo_do_elemento v)
{
    cout << "\xDB\n\xDB Nome....: " << v.nome	<< flush;
    cout << "\n\xDB Endereco: " << v.ende	<< flush;
	cout << "\n\xDB Email...: " << v.email	<< flush;
    cout << "\n\xDB Telefone: " << v.tel	<< "\n\xDB\n" << flush;
}

void imprimir(Lista A)
{
	nome();
	tipo_do_elemento v;
	int i=compr(A),j=0;
	cout << sub_titulo << "IMPRIMIR AGENDA\n";
	if(i<=0)
	cout << "\xDB\n\xDB\xDB  Agenda vazia !\n" << flush;
		else	// se existir a lista (>=1)
	{
		for(i=1;i<=compr(A);i++)
		{
			j++;
			v=consultar(A,i);
			cout << "\xDB\n\xDB  NUMERO [" << i << "]\n" << flush;
			imprime_pessoa(v);
			if(j==2) // j conta o numero de cadastro ja exibidos, a cada 2, ele limpa a tela e exibe os proximos 2
			{
				cout << "\xDB  " << flush;
				pause; 
				limpa;
				nome();
				cout << sub_titulo << "IMPRIMIR AGENDA\n";
				j=0;
			}
		}
	}
	cout << "\xDB\n\xDB  " << flush;
	pause;
}

void excluir(Lista &A,int i)
{
	tipo_do_elemento v;
	nome();
	cout << sub_titulo << "EXCLUIR CADASTRO\n";
	
	v=consultar(A,i);
	cout << "\xDB\n\xDB NUMERO [" << i << "]\n" << flush;
	imprime_pessoa(v);
	cout << "\xDB\n\xDB\xDB Digite [0] para EXCLUIR o cadastro: " << flush;
	int s=1;
	cin >> s;
	if(s==0)	// se a pessoa digitar 0, intao o cadastro selecionado ira ser eliminado
	{
	v=eliminar(A,i);
	cout << "\xDB\n\xDB\xDB Cadastro EXCLUIDO com sucesso! \n" << flush;
	}
}

void busca_pessoa(Lista &A,int opcao) // sem & no 'A', a funcao excluir, chamada aqui nessa funcao busca, nao ira funcionar....
{
	int achados=0;
	tipo_do_elemento v;
	nome();
	if(opcao==2)	// existe pois, essa funcao busca, eh chamada para busca e excluiso contatos
	cout << sub_titulo << "BUSCAR CADASTRO\n";
		else
	cout << sub_titulo << "EXCLUIR CADASTRO\n";

	if(compr(A)!=0)		// s busca se existirem mesmo cadastros....
	{
		char nome[50];
		cout << "\xDB\n\xDB\xDB  Buscar pelo nome: ";	cin.get(); cin.getline(nome,50);
		cout << "\xDB\n";
		for(int i=1;i<=compr(A);i++)
		{
			v=consultar(A,i);
			if(strstr(v.nome,nome)) // Se possuir uma parte de 'nome' em v.nome(ja cadastrado) entao..
			{
				cout << "\xDB [" << i << "] ";
				cout << v.nome << "\n" ;
				achados++; //numero de cadastrados encontrados..
			}
		}
	
		if(achados!=0) // caso ele encontre algum cadastro
		{
			int cadastro=1;
			while(cadastro!=0) // esse while, da loop, mantendo a opcao do usuario, ate ele consultar um usuario ou digitar 0...
			{
				cout << "\xDB\n\xDB\xDB  Digite o numero do cadastro ou [0] para voltar: ";
				cin >> cadastro;
				if(cadastro<=compr(A) && cadastro!=0) // precisa disso para nao dar erro de procura
				{
					v=consultar(A,cadastro);
					if(opcao==4)	// opcoao do menu -> 4 = excluir
					{ 
						excluir(A,cadastro);
						break; 
					}
					imprime_pessoa(v);
					cadastro=0;
				}
			}
		}
			else
		cout << "\xDB\n\xDB\xDB Cadastro nao encontrado !\n" << flush;
	}
	
		else // se compr(A)==0
	cout << "\xDB\n\xDB\xDB  Agenda vazia !\n" << flush;
	
	cout << "\xDB\n\xDB  " << flush;
	pause;
}

void n_cadastros(Lista A)
{
	nome();
	cout << sub_titulo << "NUMERO DE CADASTROS\n";
	cout << "\xDB\n\xDB\n\xDB\xDB Total = " << flush;
	cout << compr(A) << "\n\xDB\n\xDB\n\xDB " << flush ;
	pause;
}

int main()
{
    Lista A;
    //init(A); leia no final do codigo o pq.
	int opcao=0;
	while(opcao!=7)
	{
	nome();
	cout << "\n\xDB 1) Nova Agenda";
	cout << "\n\xDB 2) Buscar cadastro";
	cout << "\n\xDB 3) Incluir novo cadastro";
        cout << "\n\xDB 4) Excluir cadastro";
	cout << "\n\xDB 5) Imprimir agenda";
	cout << "\n\xDB 6) Numeros de Cadastros Existentes";
	cout << "\n\xDB 7) Sair";
	cout << "\n\xDB\n\xDB " << "\n\xDB Opcao " << ": ";
    
	cin >> opcao;
		switch(opcao)
		{
		case 1: leitura(A);		break;
		case 2:	busca_pessoa(A,opcao);break;
		case 3:	incluir(A);		break;
		case 4:	busca_pessoa(A,opcao);break;
		case 5: imprimir(A);	break;
		case 6:	n_cadastros(A);	break;
		case 7: break;
		default: break;
		}
    }
}

/* O QUE FOI MODIFICADO *

  Eu alterei o listaarq.h a seguinte funcao:

  int compr (Lista& l)
	{
    int comp;
	l.arq = fopen(nome_arquivo, "rb");

	if(l.arq == NULL)
	{
//		cout<<"\nErro ao abrir oarquivo";    >>>> comentei essa e a segunda linha
//		exit(1);
		return 0;			>>> e acrescentei essa linha
	}
	else 
	{
		fseek(l.arq, 0,0);
		fread(&comp, sizeof(comp),1,l.arq);
		return comp;
	}

	Eu fiz isso porque, a minha funcao leitura depende do comprimento existente da lista sem
inicia-la antes, pois se a lista fosse vazia ou nao existisse, ela exibia um titulo, 
se nao, ela perguntava se o usuario queria apagar a lista existente e criar uma nova.
	Ao meu ver, a minha maneira esta correta no decorrer da funcao leitura, por isso optei por
alterar a listaarq.h ao contrario de modificar minha funcao leitura, se nao alterar o listaarq.h
o programa saira em qq funcao (exit(1)).
	
	A outra mudana foi comentar o init(A); do void main();
*/
